#!/bin/bash

function checkipv6status()
{
    ip=$1
    sysctl -a 2>/dev/null | grep net.ipv6.conf.all.disable_ipv6 |awk -F'=' '{print $2}' | grep 1 >/dev/null 2>&1
    local all_result=$?
    sysctl -a 2>/dev/null | grep net.ipv6.conf.default.disable_ipv6 |awk -F'=' '{print $2}' | grep 1 >/dev/null 2>&1
    local default_result=$?
    if [ $all_result -eq 0 ] || [ $default_result -eq 0 ];then
        log "[ERROR]" "${LINENO}" "${ip}:IPv6 is disabled. It will cause the HA to fail to start."
    fi
}