#!/bin/bash

########################################################################################
########################################################################################
#һĸ֪ͨӿ
#--------------------------------------------------
#"0"   "2"   "${dir}" "${module}"  "mount ok"
#"1"   "2"   "${dir}" "${module}"  "partiton lost"
#"2"   "0"   "${dir}" "${module}"  "readonly"
#"2"   "1"   "${dir}" "${module}"  "readonly resume"
#--------------------------------------------------
#1Ϊ澯ID
#0Ŀ¼Ϊã֮ǰĿ¼ạ̃ҵµָ̻
#1Ŀ¼Ϊãص̷ʧ̣
#2Ŀ¼Ϊֻ: ִmount鿴ro
#
#2Ϊ澯
#0澯
#1ָ澯
#2¼ָ
#
#3ΪĿ¼/srv/BigData/datanode1
#
#4Ϊģ
#
#5ΪϢ
########################################################################################
########################################################################################

##
ParaNum=5  #Ϸ
RESULT=0   #ֵ

##5ζ
ALARM_ID=0
ALARM_TYPE=0
ALARM_DIR=""
ALARM_MODULE=""
ALARM_INFO=""

##ӡ
echo `date` "`basename $0` paras:" "[$*]"
echo `date` "`basename $0` para[1]:" "$1"
echo `date` "`basename $0` para[2]:" "$2"
echo `date` "`basename $0` para[3]:" "$3"
echo `date` "`basename $0` para[4]:" "$4"
echo `date` "`basename $0` para[5]:" "$5"

if [ $# -ne ${ParaNum} ]; then
    echo `date` "`basename $0` failed: paras num($#) is not ${ParaNum}"
    exit 1
fi


##ȷϷʼֵ
ALARM_ID=$1
ALARM_TYPE=$2
ALARM_DIR="$3"   #Ŀ¼
ALARM_MODULE="$4"   #ģzookkeep,bookeeperȣԲע
ALARM_INFO="$5"  #ϢԲע

if [[ $UID -ne 0 ]]; then
    DISKMGT_BIGDATA_HOME="${BIGDATA_HOME}"
    DISKMGT_BIGDATA_LOG_HOME="${BIGDATA_LOG_HOME}"
else
    DISKMGT_BIGDATA_HOME="$(su - omm -c 'echo $BIGDATA_HOME')"
    DISKMGT_BIGDATA_LOG_HOME="$(su - omm -c 'echo $BIGDATA_LOG_HOME')"
fi

if [ -z "${DISKMGT_BIGDATA_HOME}" ]; then
    DISKMGT_BIGDATA_HOME="/opt/huawei/Bigdata"
fi

if [ -z "${DISKMGT_BIGDATA_LOG_HOME}" ]; then
    DISKMGT_BIGDATA_LOG_HOME="/var/log/Bigdata"
fi

DISK_CONFIG_DIR="${DISKMGT_BIGDATA_HOME}/tmp/disk_manager"
DISKMGT_NOTIFY_LOG_HOME="/var/log/diskmgt/notify"
LOGFILE="${DISKMGT_NOTIFY_LOG_HOME}/confignode_notify.log"
CLOUD_FLAG_FILE="/usr/local/diskmgt/ini/cloud"

function LOG()
{
    local log_size=0

    if [ ! -d ${DISKMGT_NOTIFY_LOG_HOME} ]; then
        mkdir -p ${DISKMGT_NOTIFY_LOG_HOME}
        chown root:root ${DISKMGT_NOTIFY_LOG_HOME}
        chmod 700 ${DISKMGT_NOTIFY_LOG_HOME}
    fi

    if [ ! -e "$LOGFILE" ]; then
        touch "$LOGFILE"
        chown root:root "$LOGFILE"
        chmod 600 ${LOGFILE}
        LOG "INFO" "Set ${LOGFILE} files permission is $(ls -ld ${LOGFILE})"
    fi

    printf "`date -d today +\"%Y-%m-%d %H:%M:%S\"`,000 $1 $2\n" >> "$LOGFILE" 2>/dev/null

    log_size=`du -ms $LOGFILE |cut -f1`
    if [ $log_size -gt 50 ]; then
        #־ļ50M򱸷־ļ
        mv ${LOGFILE} ${LOGFILE}_bak
        LOG "INFO" "Change the ${LOGFILE}_bak files permission to $(ls -ld ${LOGFILE}_bak)"
    fi
}

function export_env()
{
    export JAVA_HOME=$(su - omm -c 'echo ${JAVA_HOME}')
    export JAVA=${JAVA_HOME}/bin/java
}

################################
#߼
################################
function main()
{
    #õǰumask
    UMASK=0077
    umask "$UMASK"

    export_env

    # жǷ񻷾ԼĿ¼ǷʵʹãϻұûʹõǰĿ¼űֱӷسɹis_dir_in_use255˵űִʧܣűҪԷ0ֵ˳Ҫִзؽӿڵҵ
    if [ -f ${CLOUD_FLAG_FILE} ]; then
        is_dir_in_use ${ALARM_DIR}
        local retVal=$?
        if [ $retVal -eq 1 ]; then
            LOG "INFO" "${ALARM_DIR} is not used by confignode in cloud cluster. Skip to execute partition envent."
            return 0
        elif [ $retVal -eq 255 ]; then
            LOG "ERROR" "Failed to judge whether ${ALARM_DIR} is used by confignode in cloud cluster."
            return 1
        fi
    fi

    if [ ! -d "${DISK_CONFIG_DIR}" ]; then
        mkdir -p ${DISK_CONFIG_DIR}
        chown omm:wheel ${DISK_CONFIG_DIR}
    fi
    if [ ${ALARM_ID} -eq 0 ]; then
        echo `date` "handle mount ok."
        handle_mount_ok  #Ŀ¼ָ¼
        return $?
    elif [ ${ALARM_ID} -eq 1 ]; then
        echo `date` "handle partition lost."
        handle_partition_lost #Ŀ¼豸ʧ¼
        return $?
    elif [ ${ALARM_ID} -eq 2 ]; then
        if [ ${ALARM_TYPE} -eq 0 ]; then
            echo `date` "handle ro."
            handle_readonly  #Ŀ¼ֻ澯
            return $?
        elif [ ${ALARM_TYPE} -eq 1 ]; then
            echo `date` "handle ro resume."
            handle_resume_readonly  #Ŀ¼ָֻ
            return $?
        else
            echo "Invalid AlarmType(${ALARM_TYPE})!"
            return 1
        fi
    else
        echo "Invalid AlarmID(${ALARM_ID})!"
        return 1
    fi
}

function restart_ConfigNode()
{
  local KILL_ROLE="Dproc_ConfigNode"
    LOG "INFO" "Restart ConfigNode."
    #ֹͣIoTDBServeṛȴ
    local timeout=20
    local cur_time=$(date +%s)
    local end_time
    ((end_time=cur_time+timeout))
    local process
    process=$(pgrep -f "${KILL_ROLE}")

    if [ ! -z "$process" ]; then
        kill -s SIGUSR2 "$process"
        while [ "$cur_time" -lt "$end_time" ]
        do
        tmp_pid=$(pgrep -f "${KILL_ROLE}")
        if [ ! -z "$tmp_pid" ]; then
            LOG "INFO" "sleep 1s"
            sleep 1
            cur_time=$(date +%s)
        else
            LOG "INFO" "Safe kill process."
            return
        fi
        done
    fi

    LOG "INFO" "Force kill process."
    pgrep -f "${KILL_ROLE}" | xargs sudo /bin/kill -9
    LOG "INFO" "ConfigNode process be force killed."
}

################################
#Ŀ¼ָ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_mount_ok()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) mount ok."

    # confignode
    restart_ConfigNode
    return 0
}

################################
#Ŀ¼豸ʧ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_partition_lost()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) lost."
    su - omm -c 'ENV_SH=$(find "${BIGDATA_HOME}"/FusionInsight_Current/*_*_ConfigNode/etc/confignode-env.sh);source $ENV_SH;sh "${SERVICE_HOME}"/sbin/decommission-confignode.sh'
    LOG "INFO" "Send disable disk path finish!"

    return 0
}

################################
#Ŀ¼ֻ澯
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_readonly()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly."

    # no process, return 0 directly
    return 0
}

################################
#Ŀ¼ָֻ
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_resume_readonly()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly resume."

    # iotdbserver
    restart_ConfigNode
    return 0
}

########################################################################################
# Function: is_dir_in_use
# Description: жϴĿ¼ǷΪĿ¼ʹãʹ򷵻0δʹ÷1ڲ󷵻255
# Parameter:
#   input: ·
#   N/A
# Return: 0 -- in use; 1 -- not in use; 255 -- internal error
# Others: N/A
########################################################################################
is_dir_in_use()
{
    # ¼ӦĹĿ¼
    local mountDir=${1}

    # Ŀ¼ļ·etc_UPDATEDڣʹetc_UPDATED·µļ
    local currentConfigFile=${DISKMGT_BIGDATA_HOME}/FusionInsight_Current/*_*_ConfigNode/etc/iotdb-confignode.properties
    local updateConfigFile=${DISKMGT_BIGDATA_HOME}/FusionInsight_Current/*_*_ConfigNode/etc_UPDATED/iotdb-confignode.properties

    local configFile=""
    if [ -f ${updateConfigFile} ]; then
        configFile=${updateConfigFile}
    elif [ -f ${currentConfigFile} ]; then
        configFile=${currentConfigFile}
    else
        LOG "INFO" "confignode is not install at this node."
        return 1
    fi

    # ļлȡĿ¼Ӧֵδȡش255

    local dataDirs=$(grep 'system_dir' ${configFile} | awk '{print $3}')
    if [[ -z ${dataDirs} ]]; then
        LOG "ERROR" "Can not get confignode config item system_dir in ${configFile}."
        return 255
    fi

    # жϴ˴η¼ӦĹصĿ¼ǷĿ¼Сڣ˵ʵʹˣ0δʹã1
    if [[ ${dataDirs} == *${mountDir}* ]]; then
        LOG "INFO" "Match ${mountDir} in config value ${dataDirs}. So ${mountDir} is used by confignode."
        return 0
    else
        LOG "INFO" "Cann't match ${mountDir} in config value ${dataDirs}. So ${mountDir} is not used by confignode."
        return 1
    fi
}


#ִ
main
exit $?

