#!/bin/bash

########################################################################################
########################################################################################
#һĸ֪ͨӿ
#--------------------------------------------------
#"0"   "2"   "${dir}" "${module}"  "mount ok"
#"1"   "2"   "${dir}" "${module}"  "partiton lost"
#"2"   "0"   "${dir}" "${module}"  "readonly"
#"2"   "1"   "${dir}" "${module}"  "readonly resume"
#--------------------------------------------------
#1Ϊ澯ID
#0Ŀ¼Ϊã֮ǰĿ¼ạ̃ҵµָ̻
#1Ŀ¼Ϊãص̷ʧ̣
#2Ŀ¼Ϊֻ: ִmount鿴ro
#
#2Ϊ澯
#0澯
#1ָ澯
#2¼ָ
#
#3ΪĿ¼/srv/BigData/datanode1
#
#4Ϊģ
#
#5ΪϢ
########################################################################################
########################################################################################

##
ParaNum=5  #Ϸ
RESULT=0   #ֵ

##5ζ
ALARM_ID=0
ALARM_TYPE=0
ALARM_DIR=""
ALARM_MODULE=""
ALARM_INFO=""

##ӡ
echo `date` "`basename $0` paras:" "[$*]"
echo `date` "`basename $0` para[1]:" "$1"
echo `date` "`basename $0` para[2]:" "$2"
echo `date` "`basename $0` para[3]:" "$3"
echo `date` "`basename $0` para[4]:" "$4"
echo `date` "`basename $0` para[5]:" "$5"

if [ $# -ne ${ParaNum} ]; then
    echo `date` "`basename $0` failed: paras num($#) is not ${ParaNum}"
    exit 1
fi


##ȷϷʼֵ
ALARM_ID=$1
ALARM_TYPE=$2
ALARM_DIR="$3"   #Ŀ¼
ALARM_MODULE="$4"   #ģzookkeep,bookeeperȣԲע
ALARM_INFO="$5"  #ϢԲע

###############################################################
# -----------------------------------------------------
###############################################################
declare ACTIVE_OMS="active"
declare STANDBY_OMS="standby"
declare CLOUD_FLAG_FILE="/usr/local/diskmgt/ini/cloud"
declare DISKMGT_NOTIFY_LOG_HOME="/var/log/diskmgt/notify"
declare LOGFILE="${DISKMGT_NOTIFY_LOG_HOME}/manager_om_notify.log"

if [[ $UID -ne 0 ]]; then
    DISKMGT_BIGDATA_HOME="${BIGDATA_HOME}"
    DISKMGT_BIGDATA_DATA_HOME="${BIGDATA_DATA_HOME}"
else
    DISKMGT_BIGDATA_HOME="$(su - omm -c 'echo $BIGDATA_HOME')"
    DISKMGT_BIGDATA_DATA_HOME="$(su - omm -c 'echo $BIGDATA_DATA_HOME')"
fi

if [ -z "${DISKMGT_BIGDATA_HOME}" ]; then
    DISKMGT_BIGDATA_HOME="/opt/huawei/Bigdata"
fi


###############################################################
#߼
###############################################################
function main()
{
    #õǰumask
    UMASK=0077
    umask "$UMASK"
    
    # жǷ񻷾ԼĿ¼ǷʵʹãϻұûʹõǰĿ¼űֱӷسɹis_dir_in_use255˵űִʧܣűҪԷ0ֵ˳Ҫִзؽӿڵҵ
    if [ -f ${CLOUD_FLAG_FILE} ]; then
        is_dir_in_use ${ALARM_DIR}
        local retVal=$?
        if [ $retVal -eq 1 ]; then
            LOG "INFO" "${ALARM_DIR} is not used by LocalBackup in cloud cluster. Skip to execute partition envent."
            return 0
        elif [ $retVal -eq 255 ]; then
            LOG "ERROR" "Failed to judge whether ${ALARM_DIR} is used by LocalBackup in cloud cluster."
            return 1
        fi
    fi
    
    if [ ${ALARM_ID} -eq 0 ]; then
        echo `date` "handle mount ok."
        handle_mount_ok  #Ŀ¼ָ¼
        return $?
    elif [ ${ALARM_ID} -eq 1 ]; then
        echo `date` "handle partition lost."
        handle_partition_lost #Ŀ¼豸ʧ¼
        return $?
    elif [ ${ALARM_ID} -eq 2 ]; then
        if [ ${ALARM_TYPE} -eq 0 ]; then
            echo `date` "handle ro."
            handle_readonly  #Ŀ¼ֻ澯
            return $?
        elif [ ${ALARM_TYPE} -eq 1 ]; then
            echo `date` "handle ro resume."
            handle_resume_readonly  #Ŀ¼ָֻ
            return $?
        else
            echo "Invalid AlarmType(${ALARM_TYPE})!"
            return 1
        fi
    else
        echo "Invalid AlarmID(${ALARM_ID})!"
        return 1
    fi
}

###############################################################
# ־
###############################################################
function LOG()
{
    local log_size=0

    if [ ! -d ${DISKMGT_NOTIFY_LOG_HOME} ]; then
        mkdir -p ${DISKMGT_NOTIFY_LOG_HOME}
        chown root:root ${DISKMGT_NOTIFY_LOG_HOME}
        chmod 700 ${DISKMGT_NOTIFY_LOG_HOME}
    fi
    
    if [ ! -e "$LOGFILE" ]; then
        touch "$LOGFILE"
        chown root:root "$LOGFILE"
        chmod 600 ${LOGFILE}
        LOG "INFO" "Set ${LOGFILE} files permission is $(ls -ld ${LOGFILE})"
    fi

    printf "`date -d today +\"%Y-%m-%d %H:%M:%S\"`,000 $1 $2\n" >> "$LOGFILE" 2>/dev/null

    log_size=`du -ms $LOGFILE |cut -f1`
    if [ $log_size -gt 50 ]; then
        #־ļ50M򱸷־ļ
        mv ${LOGFILE} ${LOGFILE}_bak
        LOG "INFO" "Change the ${LOGFILE}_bak files permission to $(ls -ld ${LOGFILE}_bak)"
    fi
}

########################################################################################
# Function: is_dir_in_use
# Description: жϴĿ¼ǷΪĿ¼ʹãʹ򷵻0δʹ÷1ڲ󷵻255
# ʵδװδʹøĿ¼1
# Parameter: 
#   input: ·
#   N/A
# Return: 0 -- in use; 1 -- not in use; 255 -- internal error
# Others: N/A
########################################################################################
is_dir_in_use()
{
    # ¼ӦĹĿ¼
    local mountDir=${1}
    
    if [ ! -f ${DISKMGT_BIGDATA_HOME}/om-server/om/omsetup.completed ]; then
        LOG "INFO" "Not oms node. So ${mountDir} is not used by LocalBackup module."
        return 1
    fi
    
    # mrs_image_ecs̵mountdisk.shűлᴴ$BIGDATA_DATA_HOME/LocalBackupӣӵָʹ˴η¼Ŀ¼Ƿͬͬ˵ݻָʹ
    local dataHome="$(su - omm -c 'echo $BIGDATA_DATA_HOME')"
    local backupPath="$(readlink -m ${dataHome}/LocalBackup)"
    local currentDir="$(readlink -m ${mountDir}/LocalBackup)"
    
    if [ "${backupPath}" = "${currentDir}" ]; then
        LOG "INFO" "LocalBackup path is ${backupPath}. So ${mountDir} is used by LocalBackup module."
        return 0
    else
        LOG "INFO" "LocalBackup path is ${backupPath}. So ${mountDir} is not used by LocalBackup module."
        return 1
    fi
}

################################
#Ŀ¼ָ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_mount_ok()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) mount ok."
    local dataHome="$(su - omm -c 'echo $BIGDATA_DATA_HOME')"
    local backupPath="$(readlink -m ${dataHome}/LocalBackup)"
    
    local haStatus="$(su - omm -c '$OMS_RUN_PATH/workspace/ha/module/hacom/script/get_harole.sh')"
    if [ "${haStatus}" =  "${STANDBY_OMS}" ]; then
        su - omm -c "mkdir -p ${backupPath}"
        if [ $? -ne 0 ]; then
            LOG "INFO" "Failed to execute mkdir -p ${backupPath} with user omm."
            return 1
        fi
        su - omm -c "chmod 710 ${backupPath}"
        if [ $? -ne 0 ]; then
            LOG "INFO" "Failed to execute chmod 710 ${backupPath} with user omm."
            return 1
        fi
        
        local ipModel=$(su - omm -c "grep -w "ip_model" ${DISKMGT_BIGDATA_HOME}/om-server/om/inst/conf/oms-config.ini" | awk -F"=" '{print $2}')
        local omFloatIp=$(su - omm -c "grep -w "om_float_ip" ${DISKMGT_BIGDATA_HOME}/om-server/om/inst/conf/oms-config.ini" | awk -F"=" '{print $2}')
        if [ -z "${ipModel}" ] || [ -z "${omFloatIp}" ]; then
            LOG "ERROR" "Ip model(${ipModel}) or  om float ip(${omFloatIp}) is empty."
            return 1
        fi
        
        if [ "${ipModel}" == "IPv6" ] ; then
            omFloatIp='['${omFloatIp}']'
        fi
        
        (su - omm -c "ssh ${omFloatIp} \${OMS_RUN_PATH}/workspace/ha/module/hacom/tools/ha_client_tool --ip=127.0.0.1 --port=20013 --syncfile --name=${backupPath}") >> ${LOGFILE} 2>&1 &
        local commandID=$!
        wait ${commandID} >> ${LOGFILE} 2>&1
        if [ $? -ne 0 ]; then
            LOG "ERROR" "Failed to execute syncfile command on active oms node(${omFloatIp}) for LocalBackup."
            return 1
        fi
    else
        LOG "ERROR" "Disk used by LocalBackup should be replaced on standy oms. Now this node is active oms. Please contact technical support."
        return 1
    fi
    
    return 0
}

################################
#Ŀ¼豸ʧ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_partition_lost()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) lost."
    
    return 0
}


################################
#Ŀ¼ֻ澯
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_readonly()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly."
    
    return 0
}


################################
#Ŀ¼ָֻ
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_resume_readonly()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly resume."
    
    return 0
}


#ִ
main
exit $?

