declare OMM_USER="omm"
declare OMM_WHEEL="wheel"

################################################################################
# Function: log_and_show
# Description: ־ӡ
################################################################################
log_and_show()
{
    local curTime=$(date +%Y-%m-%d\ %T)
    local level=$1
    local lineNo=$2
    local logInfo=$3
    
    echo "[$curTime] [$level]: $logInfo(line:$lineNo)" >> "${LOG_FILE}" 2>&1
    echo "$logInfo"
}

[ -f "/home/omm/.profile" ] && source "/home/omm/.profile"
[ -f "/home/omm/.basrc" ] && source "/home/omm/.basrc"

g_LogHome=$(su - omm -c 'echo ${BIGDATA_LOG_HOME}')

g_LogPath="${g_LogHome}/patch"
if ! [ -d "${g_LogPath}" ]; then
    mkdir -p "${g_LogPath}"
    chown "${OMM_USER}:${OMM_WHEEL}" "$g_LogPath" -R
fi

LOG_FILE="${g_LogPath}/os_optimization.log"
# ־ļ޸ļȨ
if [ ! -f "${LOG_FILE}" ] ; then
    touch "${LOG_FILE}"
    chown "${OMM_USER}:${OMM_WHEEL}" "$LOG_FILE"
fi

chmod 700 "${g_LogPath}"
chmod 600 "${LOG_FILE}"
