#!/bin/bash


function checkUserAndId()
{
    ip=$1
    log "[INFO]" "${LINENO}" "${ip}: start checking user and id."

    g_ommUsername=$2
    g_ommUserid=$3
    
    ommuser=$(cat /etc/passwd | grep -v "^\s*#" | awk -F":" '{print $1}' | grep "${g_ommUsername}")
    ommid=$(cat /etc/passwd | grep -v "^\s*#" | awk -F":" '{print $3}' | grep "${g_ommUserid}")
    if [ -n "${ommuser}" ]
    then
        log "[ERROR]" "${LINENO}" "${ip}: user '${g_ommUsername}' already exist, please remove user first."
    fi
    
    if [ x"${ommid}" = x"${g_ommUserid}" ]
    then
        log "[ERROR]" "${LINENO}" "${ip}: user id '${g_ommUserid}' already exist, please remove user first."
    fi
}