#!/bin/bash
checksudoers()
{
    log "[INFO]" "${LINENO}" "${ip}: start checking the 'Defaults requiretty'"  
    ip=$1

    checkDefaultsrequiretty
    if [ $? -ne 0 ]
    then 
        log "[ERROR]" "${LINENO}" "${ip}: 'Defaults requiretty' is configured incorrectly in '/etc/sudoers' the file."
    fi
    
}

checkDefaultsrequiretty()
{
    result=0
    #检查/etc/sudoers中是否配置Defaults requiretty
    checkResult=$(${CMD_CHKSUDOERS} |grep "^Defaults *requiretty")
    if [ -n "${checkResult}" ]
    then
        log "[ERROR_DEBUG]" "${LINENO}" "${ip}: '${checkResult}' is configured in '/etc/sudoers' the file."
        result=1
    fi
    #检查/etc/sudoers中是否配置Defaults:xxx !requiretty
    checkResult=$(${CMD_CHKSUDOERS} |grep "^Defaults *:.* \!requiretty")
    if [ -n "${checkResult}" ];then
        checkomm=$(${CMD_CHKSUDOERS} | grep "^Defaults *: *omm * \!requiretty")
        if [ "${checkResult}" != "${checkomm}" ];then
            log "[ERROR_DEBUG]" "${LINENO}" "${ip}: '${checkResult}' is configured in '/etc/sudoers' the file."
            result=1
        fi
    fi
    
    return ${result}
}


