#!/bin/bash

########################################################################################
########################################################################################
#һĸ֪ͨӿ
#--------------------------------------------------
#"0"   "2"   "${dir}" "${module}"  "mount ok"
#"1"   "2"   "${dir}" "${module}"  "partiton lost"
#"2"   "0"   "${dir}" "${module}"  "readonly"
#"2"   "1"   "${dir}" "${module}"  "readonly resume"
#--------------------------------------------------
#1Ϊ澯ID
#0Ŀ¼Ϊã֮ǰĿ¼ạ̃ҵµָ̻
#1Ŀ¼Ϊãص̷ʧ̣
#2Ŀ¼Ϊֻ: ִmount鿴ro
#
#2Ϊ澯
#0澯
#1ָ澯
#2¼ָ
#
#3ΪĿ¼/srv/BigData/datanode1
#
#4Ϊģ
#
#5ΪϢ
########################################################################################
########################################################################################

##
ParaNum=5  #Ϸ
RESULT=0   #ֵ

##5ζ
ALARM_ID=0
ALARM_TYPE=0
ALARM_DIR=""
ALARM_MODULE=""
ALARM_INFO=""

##ӡ
echo "$(date)" "$(basename "$0") paras:" "[$*]"
echo "$(date)" "$(basename "$0") para[1]:" "$1"
echo "$(date)" "$(basename "$0") para[2]:" "$2"
echo "$(date)" "$(basename "$0") para[3]:" "$3"
echo "$(date)" "$(basename "$0") para[4]:" "$4"
echo "$(date)" "$(basename "$0") para[5]:" "$5"

if [ $# -ne ${ParaNum} ]; then
    echo "$(date)" "$(basename "$0") failed: paras num($#) is not ${ParaNum}"
    exit 1
fi

declare HA_ACTIVE_STATUS="active"
declare HA_STANDBY_STATUS="standby"
declare HA_SINGLE_STATUS="single"
declare HACOM_PATH=""
declare OMS_RUN_PATH=""
declare CLOUD_FLAG_FILE="/usr/local/diskmgt/ini/cloud"
##ȷϷʼֵ
ALARM_ID=$1
ALARM_TYPE=$2
ALARM_DIR="$3"   #Ŀ¼
ALARM_MODULE="$4"   #ģzookkeep,bookeeperȣԲע
ALARM_INFO="$5"  #ϢԲע
if [[ $UID -ne 0 ]]; then
    DISKMGT_BIGDATA_HOME="${BIGDATA_HOME}"
    DISKMGT_BIGDATA_LOG_HOME="${BIGDATA_LOG_HOME}"
    DISKMGT_BIGDATA_OM_SERVER_HOME="${BIGDATA_OM_SERVER_HOME}"
    DISKMGT_OMS_RUN_PATH="${OMS_RUN_PATH}"
    DISKMGT_BIGDATA_DATA_HOME="${BIGDATA_DATA_HOME}"
else
    DISKMGT_BIGDATA_HOME="$(su - omm -c 'echo $BIGDATA_HOME')"
    DISKMGT_BIGDATA_LOG_HOME="$(su - omm -c 'echo $BIGDATA_LOG_HOME')"
    DISKMGT_BIGDATA_OM_SERVER_HOME="$(su - omm -c 'echo $BIGDATA_OM_SERVER_HOME')"
    DISKMGT_OMS_RUN_PATH="$(su - omm -c 'echo $OMS_RUN_PATH')"
    DISKMGT_BIGDATA_DATA_HOME="$(su - omm -c 'echo $BIGDATA_DATA_HOME')"
fi

if [ -z "${DISKMGT_BIGDATA_HOME}" ]; then
    DISKMGT_BIGDATA_HOME="/opt/huawei/Bigdata"
fi

if [ -z "${DISKMGT_BIGDATA_LOG_HOME}" ]; then
    DISKMGT_BIGDATA_LOG_HOME="/var/log/Bigdata"
fi

if [ -z "${DISKMGT_BIGDATA_DATA_HOME}" ]; then
    DISKMGT_BIGDATA_DATA_HOME="/srv/BigData"
fi

if [ ! -z "${DISKMGT_BIGDATA_OM_SERVER_HOME}" ] && [ ! -z "${DISKMGT_OMS_RUN_PATH}" ]; then
    HACOM_PATH="${DISKMGT_BIGDATA_OM_SERVER_HOME}/OMS/workspace/ha/module/hacom"
    OMS_RUN_PATH="${DISKMGT_OMS_RUN_PATH}/workspace/conf"
fi

DISKMGT_NOTIFY_LOG_HOME="/var/log/diskmgt/notify"
LOGFILE="${DISKMGT_NOTIFY_LOG_HOME}/container_notify.log"

################################
#߼
################################
function main()
{
    #õǰumask
    UMASK=0077
    umask "$UMASK"

    # жǷ񻷾ԼĿ¼ǷʵʹãϻұûʹõǰĿ¼űֱӷسɹis_dir_in_use255˵űִʧܣűҪԷ0ֵ˳Ҫִзؽӿڵҵ
    if [ -f ${CLOUD_FLAG_FILE} ]; then
        is_dir_in_use ${ALARM_DIR}
        local retVal=$?
        if [ $retVal -eq 1 ]; then
            LOG "INFO" "${ALARM_DIR} is not used by container in cloud cluster. Skip to execute partition envent."
            return 0
        elif [ $retVal -eq 255 ]; then
            LOG "INFO" "Failed to judge whether ${ALARM_DIR} is used by container in cloud cluster."
            return 1
        fi
    fi

    if [ "${ALARM_ID}" -eq 0 ]; then
        echo "$(date)" "handle mount ok."
        handle_mount_ok  #Ŀ¼ָ¼
        sync_file_to_master #OMSڵִļͬ
        return $?
    elif [ "${ALARM_ID}" -eq 1 ]; then
        echo "$(date)" "handle partition lost."
        handle_partition_lost #Ŀ¼豸ʧ¼
        return $?
    elif [ "${ALARM_ID}" -eq 2 ]; then
        if [ "${ALARM_TYPE}" -eq 0 ]; then
            echo "$(date)" "handle ro."
            handle_readonly  #Ŀ¼ֻ澯
            return $?
        elif [ "${ALARM_TYPE}" -eq 1 ]; then
            echo "$(date)" "handle ro resume."
            handle_resume_readonly  #Ŀ¼ָֻ
            return $?
        else
            echo "Invalid AlarmType(${ALARM_TYPE})!"
            return 1
        fi
    else
        echo "Invalid AlarmID(${ALARM_ID})!"
        return 1
    fi
}

function LOG()
{
    local log_size=0

    if [ ! -d ${DISKMGT_NOTIFY_LOG_HOME} ]; then
        mkdir -p ${DISKMGT_NOTIFY_LOG_HOME}
        chown root:root ${DISKMGT_NOTIFY_LOG_HOME}
        chmod 700 ${DISKMGT_NOTIFY_LOG_HOME}
    fi

    if [ ! -e "$LOGFILE" ]; then
        touch "$LOGFILE"
        chown root:root "$LOGFILE"
        LOG "INFO" "Set ${LOGFILE} files permission is $(ls -ld "${LOGFILE}")"
    fi

    printf "$(date -d today +"%Y-%m-%d %H:%M:%S",000) %s %s\n" "$1" "$2" >> "$LOGFILE" 2>/dev/null

    log_size=$(du -ms "$LOGFILE" |cut -f1)
    if [ "$log_size" -gt 50 ]; then
        #־ļ50M򱸷־ļ
        mv "${LOGFILE}" "${LOGFILE}"_bak
        LOG "INFO" "Change the ${LOGFILE}_bak files permission to $(ls -ld "${LOGFILE}"_bak)"
    fi
}

function initEnv()
{
    LOG "INFO" "module(${ALARM_MODULE}): Start init env."
    NODE_AGENT_HOME=$(su - omm -c "echo ${NODE_AGENT_HOME}")
    export NODE_AGENT_HOME
    ENV_VARS=$(find "${DISKMGT_BIGDATA_HOME}"/FusionInsight_Current/*_*_WebContainer_*/etc/ENV_VARS | tail -1)
    if  [ -z "${ENV_VARS}" ]; then
        LOG "WARN" "Env vars does not exist, unable to check sync status"
        return 1
    fi

    CONTAINER_BASE_DATA_DIR=$(cat "${ENV_VARS}" | grep "CONTAINER_BASE_DATA_DIR" | awk -F '=' '{print $2}')
    export CONTAINER_BASE_DATA_DIR
    CONTAINER_ENGINE_WAR=$(find "${DISKMGT_BIGDATA_HOME}"/FusionInsight_Current/*_*_WebContainer_*/install/container/war/ContainerEngine.war | tail -1)
    export CONTAINER_ENGINE_WAR
    LOG "INFO" "container engine war path is ${CONTAINER_ENGINE_WAR}"
    CONTAINER_DIR=$(find "${DISKMGT_BIGDATA_HOME}"/FusionInsight_Current/*_*_WebContainer_*)
    export CONTAINER_DIR
}
################################
#Ŀ¼ָ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_mount_ok()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) mount ok."
    if ! initEnv; then
        return 1
    fi
    mkdir -p "${CONTAINER_BASE_DATA_DIR}"/common/sync
    for CONTAINER_PATH in $CONTAINER_DIR; do
        BASE_CONTAINER=$(basename "${CONTAINER_PATH}")
        CONTAINER=${BASE_CONTAINER##*_*_Web}
        LOG "INFO" "Find container ${CONTAINER}"
        mkdir -p "${CONTAINER_BASE_DATA_DIR}"/container/"${CONTAINER}"/prepare
        if [ ! -d "${CONTAINER_BASE_DATA_DIR}"/container/"${CONTAINER}"/webapps ] ;then
            mkdir -p "${CONTAINER_BASE_DATA_DIR}"/container/"${CONTAINER}"/webapps
        fi
        cp -f "${CONTAINER_ENGINE_WAR}" "${CONTAINER_BASE_DATA_DIR}"/container/"${CONTAINER}"/webapps
    done
    chown omm:wheel "${CONTAINER_BASE_DATA_DIR}" -R
}

################################
#Ŀ¼豸ʧ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_partition_lost()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) lost."
    # OMSڵContainer̰γʱִ
    switchover
    if [ $? -ne 0 ]; then
        LOG "ERROR" "execute switchover failed"
        return 1;
    fi
    return 0;
}


################################
#Ŀ¼ֻ澯
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_readonly()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly."
    switchover
    if [ $? -ne 0 ]; then
        LOG "ERROR" "execute switchover failed"
        return 1;
    fi
    return 0;
}

################################
#ִ
#ɹ0򷵻ط0
################################
function switchover()
{
    check_container_upload
    if [ $? -ne 0 ]; then
      LOG "INFO" "container upload blu data no exist"
      return 0;
    fi

    if [ ! -z "${HACOM_PATH}" ]; then
        local ha_status=$(${HACOM_PATH}/script/get_harole.sh)
        local ha_mode=$(${HACOM_PATH}/script/config_ha.sh -a | grep "^HaMode" | awk '{ print $2 }')
        if [[ "$ha_status" == "${HA_ACTIVE_STATUS}" ]] && [[ "$ha_mode" != "${HA_SINGLE_STATUS}" ]]; then
          su - omm -c "${HACOM_PATH}/tools/ha_client_tool --ip=127.0.0.1 --port=20013 --switchover --name=product >/dev/null 2>&1"
          if [ $? -ne 0 ]; then
              return 1;
          fi
        fi
    fi
    return 0
}

################################
#ִļͬ
#ɹ0򷵻ط0
# <file name="/srv/BigData/containers/common/proto" />
# <file name="/srv/BigData/containers/common/upload" />
# <file name="/srv/BigData/containers/common/repository" />
################################
function sync_file_to_master()
{

    check_container_upload
    if [ $? -ne 0 ]; then
      LOG "INFO" "container upload blu data no exist"
      return 0;
    fi

    if [ ! -z "${HACOM_PATH}" ]; then
        local ha_status=$(${HACOM_PATH}/script/get_harole.sh)
        local ha_mode=$(${HACOM_PATH}/script/config_ha.sh -a | grep "^HaMode" | awk '{ print $2 }')
        if [[ "$ha_status" == "${HA_STANDBY_STATUS}" ]] && [[ "$ha_mode" != "${HA_SINGLE_STATUS}" ]]; then
          local ommFloatIp=$(cat ${OMS_RUN_PATH}/oms-config.ini | grep -w 'om_float_ip' | awk -F '=' '{ print $2 }')
          su - omm -c "ssh ${ommFloatIp} '${HACOM_PATH}/tools/ha_client_tool --syncfile --name=${CONTAINER_BASE_DATA_DIR}/common/proto;
          ${HACOM_PATH}/tools/ha_client_tool --syncfile --name=${CONTAINER_BASE_DATA_DIR}/common/upload;
          ${HACOM_PATH}/tools/ha_client_tool --syncfile --name=${CONTAINER_BASE_DATA_DIR}/common/repository'"
          if [ $? -ne 0 ]; then
              return 1;
          fi
        fi
    fi
    return 0
}

################################
#УcontainerǷҵ
#ɹ0򷵻ط0
################################
function check_container_upload()
{
    local uploadDirs="${DISKMGT_BIGDATA_DATA_HOME}/containers/common/upload"
    if [ -f "${DISKMGT_BIGDATA_OM_SERVER_HOME}/om/etc/om/hcs.properties" ]; then
        uploadDirs="${DISKMGT_BIGDATA_DATA_HOME}/data1/containers/common/upload";
    fi
    echo "${uploadDirs}" | grep -qw "${ALARM_DIR}"
    if [ $? -eq 0 ] && [ -d ${uploadDirs} ]; then
      LOG "INFO" "Match ${ALARM_DIR} in config value ${uploadDirs}. So ${ALARM_DIR} is used by Container."
      return 0
    fi
    return 1
}

########################################################################################
# Function: is_dir_in_use
# Description: жϴĿ¼ǷΪĿ¼ʹãʹ򷵻0δʹ÷1ڲ󷵻255
# ʵδװδʹøĿ¼1
# Parameter:
#   input: ·
#   N/A
# Return: 0 -- in use; 1 -- not in use; 255 -- internal error
# Others: N/A
########################################################################################
is_dir_in_use()
{
    # ¼ӦĹĿ¼
    local mountDir="${1}"

    # жomsڵǷcontainerҵ
    check_container_upload
    if [ $? -eq 0 ]; then
      LOG "INFO" "container blu data exist"
      return 0;
    fi

    # Ŀ¼ļ·etc_UPDATEDڣʹetc_UPDATED·µļ
    local currentConfigFile=$(find "${DISKMGT_BIGDATA_HOME}"/FusionInsight_Current/*_*_WebContainer_*/etc/ENV_VARS | tail -1)
    local updateConfigFile=$(find "${DISKMGT_BIGDATA_HOME}"/FusionInsight_Current/*_*_WebContainer_*/etc_UPDATED/ENV_VARS | tail -1)

    # ļڣմnotifyűӦʵδʹĿ¼д
    local configFile=""
    if [ ! -z ${updateConfigFile} ]; then
        configFile=${updateConfigFile}
    elif [ ! -z ${currentConfigFile} ]; then
        configFile=${currentConfigFile}
    else
        LOG "INFO" "container is not install at this node."
        return 1
    fi

    # ļлȡĿ¼Ӧֵδȡش255
    local dataDirs=$(cat "${configFile}" | grep "CONTAINER_BASE_DATA_DIR" | awk -F '=' '{print $2}')
    if [ -z ${dataDirs} ]; then
        LOG "ERROR" "Can not get container config item container.data.dir in ${configFile}."
        return 255
    fi

    # жϴ˴η¼ӦĹصĿ¼ǷĿ¼Сڣ˵ʵʹˣ0δʹã1
    echo "${dataDirs}" | grep -qw "${mountDir}"
    if [ $? -eq 0 ]; then
        LOG "INFO" "Match ${mountDir} in config value ${dataDirs}. So ${mountDir} is used by Container."
        return 0
    else
        LOG "INFO" "Cann't match ${mountDir} in config value ${dataDirs}. So ${mountDir} is not used by Container."
        return 1
    fi

}

################################
#Ŀ¼ָֻ
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_resume_readonly()
{
    echo "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly resume."

    return 0
}


#ִ
main
exit $?

