#!/bin/bash

########################################################################################
########################################################################################
#һĸ֪ͨӿ
#--------------------------------------------------
#"0"   "2"   "${dir}"  "${module}"  "mount ok"
#"1"   "2"   "${dir}"  "${module}"  "partiton lost"
#"2"   "0"   "${dir}"  "${module}"  "readonly"
#"2"   "1"   "${dir}"  "${module}"  "readonly resume"
#--------------------------------------------------
#1Ϊ澯ID
#0Ŀ¼Ϊã֮ǰĿ¼ạ̃ҵµָ̻
#1Ŀ¼Ϊãص̷ʧ̣
#2Ŀ¼Ϊֻ: ִmount鿴ro
#
#2Ϊ澯
#0澯
#1ָ澯
#2¼ָ
#
#3ΪĿ¼/srv/BigData/datanode1
#
#4Ϊģ
#
#5ΪϢ
########################################################################################
########################################################################################

##
ParaNum=5  #Ϸ
RESULT=0   #ֵ

##5ζ
ALARM_ID=0
ALARM_TYPE=0
ALARM_DIR=""
ALARM_MODULE=""
ALARM_INFO=""

##ӡ
echo `date` "`basename $0` paras:" "[$*]"
echo `date` "`basename $0` para[1]:" "$1"
echo `date` "`basename $0` para[2]:" "$2"
echo `date` "`basename $0` para[3]:" "$3"
echo `date` "`basename $0` para[4]:" "$4"
echo `date` "`basename $0` para[5]:" "$5"

if [ $# -ne ${ParaNum} ]; then
    echo `date` "`basename $0` failed: paras num($#) is not ${ParaNum}"
    exit 1
fi


##ȷϷʼֵ
ALARM_ID=$1
ALARM_TYPE=$2
ALARM_DIR="$3"   #Ŀ¼
ALARM_MODULE="$4"   #ģzookkeep,bookeeperȣԲע
ALARM_INFO="$5"  #ϢԲע

if [[ $UID -ne 0 ]]; then
    DISKMGT_BIGDATA_HOME="${BIGDATA_HOME}"
else
    DISKMGT_BIGDATA_HOME="$(su - omm -c 'echo $BIGDATA_HOME')"
fi

if [ -z "${DISKMGT_BIGDATA_HOME}" ]; then
    DISKMGT_BIGDATA_HOME="/opt/huawei/Bigdata"
fi

DISK_CONFIG_DIR="${DISKMGT_BIGDATA_HOME}/tmp/disk_manager"
DISABLE_DIR_LIST="${DISK_CONFIG_DIR}/disable_dir_list"
CLOUD_FLAG_FILE="/usr/local/diskmgt/ini/cloud"

DISKMGT_NOTIFY_LOG_HOME="/var/log/diskmgt/notify"
LOGFILE="${DISKMGT_NOTIFY_LOG_HOME}/datanode_notify.log"


function LOG()
{
    local log_size=0

    if [ ! -d ${DISKMGT_NOTIFY_LOG_HOME} ]; then
        mkdir -p ${DISKMGT_NOTIFY_LOG_HOME}
        chown root:root ${DISKMGT_NOTIFY_LOG_HOME}
        chmod 700 ${DISKMGT_NOTIFY_LOG_HOME}
    fi
    
    if [ ! -e "$LOGFILE" ]; then
        touch "$LOGFILE"
        chown root:root "$LOGFILE"
        chmod 600 ${LOGFILE}
        LOG "INFO" "Set ${LOGFILE} files permission is $(ls -ld ${LOGFILE})"
    fi

    printf "`date -d today +\"%Y-%m-%d %H:%M:%S\"`,000 $1 $2\n" >> "$LOGFILE" 2>/dev/null

    log_size=`du -ms $LOGFILE |cut -f1`
    if [ $log_size -gt 50 ]; then
        #־ļ50M򱸷־ļ
        mv ${LOGFILE} ${LOGFILE}_bak
        LOG "INFO" "Change the ${LOGFILE}_bak files permission to $(ls -ld ${LOGFILE}_bak)"
    fi
}

################################
#߼
################################
function main()
{
    #õǰumask
    UMASK=0077
    umask "$UMASK"

    # жǷ񻷾ԼĿ¼ǷʵʹãϻұûʹõǰĿ¼űֱӷسɹis_dir_in_use255˵űִʧܣűҪԷ0ֵ˳Ҫִзؽӿڵҵ
    if [ -f ${CLOUD_FLAG_FILE} ]; then
        is_dir_in_use ${ALARM_DIR}
        local retVal=$?
        if [ $retVal -eq 1 ]; then
            LOG "INFO" "${ALARM_DIR} is not used by DataNode in cloud cluster. Skip to execute partition envent."
            return 0
        elif [ $retVal -eq 255 ]; then
            LOG "INFO" "Failed to judge whether ${ALARM_DIR} is used by DataNode in cloud cluster."
            return 1
        fi
    fi
    
    # ¼߼
    if [ ! -d "${DISK_CONFIG_DIR}" ]; then
        mkdir -p ${DISK_CONFIG_DIR}
        chown omm:wheel ${DISK_CONFIG_DIR}
        LOG "INFO" "Set ${DISK_CONFIG_DIR} files permission is $(ls -ld ${DISK_CONFIG_DIR})"
    fi

    if [ ${ALARM_ID} -eq 0 ]; then
        echo `date` "handle mount ok."
        handle_mount_ok  #Ŀ¼ָ¼
        return $?
    elif [ ${ALARM_ID} -eq 1 ]; then
        echo `date` "handle partition lost."
        handle_partition_lost #Ŀ¼豸ʧ¼
        return $?
    elif [ ${ALARM_ID} -eq 2 ]; then
        if [ ${ALARM_TYPE} -eq 0 ]; then
            echo `date` "handle ro."
            handle_readonly  #Ŀ¼ֻ澯
            return $?
        elif [ ${ALARM_TYPE} -eq 1 ]; then
            echo `date` "handle ro resume."
            handle_resume_readonly  #Ŀ¼ָֻ
            return $?
        else
            echo "Invalid AlarmType(${ALARM_TYPE})!"
            return 1
        fi
    else
        echo "Invalid AlarmID(${ALARM_ID})!"
        return 1
    fi
}

########################################################################################
# Function: is_dir_in_use
# Description: жϴĿ¼ǷΪĿ¼ʹãʹ򷵻0δʹ÷1ڲ󷵻255
# ʵδװδʹøĿ¼1
# Parameter: 
#   input: ·
#   N/A
# Return: 0 -- in use; 1 -- not in use; 255 -- internal error
# Others: N/A
########################################################################################
is_dir_in_use()
{
    # ¼ӦĹĿ¼
    local ALARM_DIR_DN=${1}
    
    # Ŀ¼ļ·etc_UPDATEDڣʹetc_UPDATED·µļ
    local currentConfigFile=${DISKMGT_BIGDATA_HOME}/FusionInsight_Current/*_*_DataNode/etc/hdfs-site.xml
    local updateConfigFile=${DISKMGT_BIGDATA_HOME}/FusionInsight_Current/*_*_DataNode/etc_UPDATED/hdfs-site.xml
    
    local configFile=""
    if [ -f ${updateConfigFile} ]; then
        configFile=${updateConfigFile}
    elif [ -f ${currentConfigFile} ]; then
        configFile=${currentConfigFile}
    else
        LOG "INFO" "DataNode is not install at this node."
        return 1
    fi

    # datanode̸ʱѽĿ¼dfs.datanode.data.dirƳ
    # ԣ̸볡ҪǷ̺УڣʾdatanodeʱָܻôʹãҪ0
    local configDir=$(dirname $configFile)
    local dnBlackListFile=$(find "${configDir}/DN_ISOLATE_DIRS")
    if [ -n "${dnBlackListFile}" ]; then
        cat $dnBlackListFile |grep "${ALARM_DIR_DN}/dn" 2>/dev/null
        if [ $? -eq 0 ]; then
            LOG "INFO" "Find ${ALARM_DIR_DN}/dn in DN_ISOLATE_DIRS black list, so dir is used by DataNode"
            return 0
        fi
    fi

    # ļлȡĿ¼Ӧֵδȡش255
    local dataDirs=$(grep -A 1 '<name>dfs.datanode.data.dir</name>' ${configFile} | tail -n 1)
    if [ -z ${dataDirs} ]; then
        LOG "ERROR" "Can not get DataNode config item dfs.datanode.data.dir in ${configFile}."
        return 255
    fi

    local mountDir="${ALARM_DIR_DN}/dn"

    # жϴ˴η¼ӦĹصĿ¼ǷĿ¼Сڣ˵ʵʹˣ0δʹã1
    echo ${dataDirs} | grep -qw ${mountDir}
    if [ $? -eq 0 ]; then
        LOG "INFO" "Match ${mountDir} in config value ${dataDirs}. So ${mountDir} is used by DataNode."
        return 0
    else
        LOG "INFO" "Cann't match ${mountDir} in config value ${dataDirs}. So ${mountDir} is not used by DataNode."
        return 1
    fi
}

function restart_datanode()
{
    local pid=""

    #ɱdatanodẹöʱdatanode
    pid=$(ps -efww | grep proc_datanode | grep java |grep -v grep | awk '{print $2}' |xargs echo)
    if [ -z "${pid}" ]; then
        LOG "INFO" "Can not find datanode process."
        return 0
    fi

    LOG "INFO" "Kill datanode process, pid=[${pid}]."
    sudo /bin/kill -9 ${pid}
}

function stop_impalad()
{
    local pid=""

    #ɱimpalaḍöʱimpalad
    pid=$(ps -efww | grep "impala-huawei/usr/bin/impalad" | grep -v grep | awk '{print $2}' |xargs echo)
    if [ -z "${pid}" ]; then
        LOG "INFO" "Can not find impalad process."
        return 0
    fi

    LOG "INFO" "Kill impalad process, pid=[${pid}]."
    sudo /bin/kill -9 ${pid}
}

# judge is impalad scratch dir configurated on lost or recovery directory
# 1: impala impalad scratch dir configurated on it
# 0: impala impalad scratch dir did not configurated on it
function judge_action()
{
        find ${DISKMGT_BIGDATA_HOME}/FusionInsight/etc/*_*_Impalad/ENV_VARS | xargs cat | grep "IMPALA_SCRATCH_DIR" | grep "${ALARM_DIR}" >> /dev/null
        if [ $? -eq 0 ] ; then
             return 1
        else
             return 0
        fi
}

################################
#impalaĿ¼ָ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_impala_mount_ok()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) mount ok."

        `judge_action`

         if [ $? -eq 1 ] ; then

                #ñ־ָimpalad
                echo 0 > ${DISABLE_IMPALAD}
                chown omm:wheel ${DISABLE_IMPALAD}
                LOG "INFO" "Recover sign for impalad Set ${DISABLE_IMPALAD} files permission is $(ls -ld ${DISABLE_IMPALAD})"
                #stop impalad
                stop_impalad
         fi

    return 0
}

################################
#impalaĿ¼豸ʧ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_impala_partition_lost()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) lost."

        `judge_action`

        if [ $? -eq 1 ] ; then

            #ñ־ֹimpalad
            echo 1 > ${DISABLE_IMPALAD}
            chown omm:wheel ${DISABLE_IMPALAD}
            LOG "INFO" "Forbidden sign for impalad  Set ${DISABLE_IMPALAD} files permission is $(ls -ld ${DISABLE_IMPALAD})"
            #stop impalad
            stop_impalad
       fi

    return 0
}

# judge is Elk datanode dir configurated on lost or recovery directory
# 1 current alarm directory has Elk data
# 0 current alarm directory does not have Elk data
function judge_Elk_action()
{
    find ${DISKMGT_BIGDATA_HOME}/FusionInsight_Current/*_*_ElkServer/install/elk-install-config.xml | xargs cat | grep "${ALARM_DIR}" >> /dev/null
    if [ $? -eq 0 ] ; then
         return 1
    else
         return 0
    fi
}

function handle_Elk_mount_ok()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) mount ok."

    judge_Elk_action
    if [ $? -eq 1 ] ; then

        local g_elkInstallPath=$(find "${DISKMGT_BIGDATA_HOME}"/FusionInsight_Current/*_*_ElkServer/etc/ENV_VARS | xargs cat | grep "ELK_SOFTWARE_PATH" | awk -F"=" '{print $2}')
        [ -z "$g_elkInstallPath" ] && return 0
            
        # one node just one process to deal 
        isExist=$(ps -ef | grep "${g_elkInstallPath}/package/ELK_MPPDB/script/gs_replace" | grep -v grep)
        if [ -z "$isExist" ];then
            LOG "INFO" "The process gs_replace is not exist, now start it."
            
            ret=$(su - omm -s /bin/bash ${g_elkInstallPath}/sbin/elk-repair.sh)
            if [ $ret -ne 0 ]; then
                LOG "ERROR" "replace node configure failed, result is $?"
                return 1
            fi
        fi
        
    fi

    return 0
}

function getConf()
{
    local confFile="$1"
    local confKey="$2"

    local lineIndex=$(grep -nF "<name>${confKey}</name>" "${confFile}" | awk -F ':' '{print $1}' 2>/dev/null)
    if [ -z "${lineIndex}" ]; then
        LOG "ERROR" "No property (${confKey}) in ${confFile}"
        return 1
    fi

    ((lineIndex=lineIndex+1))

    local valueline=$(awk -v i=${lineIndex} 'NR==i{print}' "${confFile}" | grep '<value>' 2>/dev/null)
    if [ -z "${valueline}" ]; then
        local valueline=$(awk -v i=${lineIndex} 'NR==i{print}' "${confFile}" | grep '<value/>' 2>/dev/null)
        if [ -z "${valueline}" ]; then
            LOG "ERROR" "No value of property (${confKey}) in ${confFile}"
            return 1
        fi
        #ؿֵ
        local confValue
        echo "${confValue}"
        return 0
    fi

    local confValue=$(echo "${valueline}" | sed 's#.*<value>##g' | sed 's#</value>.*##g' 2>/dev/null)
    echo "${confValue}"
}

function setConf()
{
    local confFile="$1"
    local confKey="$2"
    local confValue="$3"

    local lineIndex=$(grep -nF "<name>${confKey}</name>" "${confFile}"| awk -F ':' '{print $1}' 2>/dev/null)
    if [ -z "${lineIndex}" ]; then
        LOG "ERROR" "No property (${confKey}) in ${confFile}"
        return 1
    fi

    ((lineIndex=lineIndex+1))

    local valueline=$(awk "NR==${lineIndex}{print}" "${confFile}" | grep "<value>" 2>/dev/null)
    if [ -z "${valueline}" ]; then
        local valueline=$(awk "NR==${lineIndex}{print}" "${confFile}" | grep "<value/>" 2>/dev/null)
        if [ -z "${valueline}" ]; then
            LOG "ERROR" "No value of property (${confKey}) in ${confFile}"
            return 1
        fi
    fi

    sed -i "${lineIndex}{s#.*#<value>${confValue}</value>#}" "${confFile}" 2>/dev/null
    if [ $? -ne 0 ]; then
        LOG "ERROR" "Fail to set ${confValue} to property (${confKey}) in ${confFile}"
        return 1
    fi
}

function clean_dir_black_list() {
    local isolatedDisk=$1
    local blackListFile=$2

    local dirBlackListStr=$(cat $blackListFile)

    # ޳Ŀ¼
    LOG "INFO" "to disable isolation disk $isolatedDisk from black list $dirBlackListStr"
    echo $dirBlackListStr |grep $isolatedDisk
    if [ $? -eq 0 ]; then
        LOG "INFO" "Isolated dir $isolatedDisk found in black list $dirBlackListStr"
        sed -i "s|^${isolatedDisk}$||g" ${blackListFile}
        sed -i "/^$/d" ${blackListFile}
    fi
}

function setDnDirConf() {
    local isolatedDisk=$1

    local confKey="dfs.datanode.data.dir"
    local confFile=$(find "${DISKMGT_BIGDATA_HOME}"/FusionInsight_Current/*_*_DataNode/etc/hdfs-site.xml)
    if [ -z "${confFile}" ]; then
        LOG "ERROR" "Config file hdfs-site.xml not found."
        return 1
    fi

    local currentDirsStr=$(getConf ${confFile} "dfs.datanode.data.dir")
    echo ${currentDirsStr} |grep ${isolatedDisk} 1>/dev/null 2>/dev/null
    if [ $? -ne 0 ]; then
        setConf ${confFile} "dfs.datanode.data.dir" ${currentDirsStr}","${isolatedDisk}
    fi
}

######################################
#̺صָʹô
#datanodenodemanagerĴ̺
#ɹ0򷵻ط0
######################################
function handle_dir_black_list() {
    LOG "INFO" "start clean dn&nm black list."

    #datanode
    local dnBlackListFile=$(find "${DISKMGT_BIGDATA_HOME}"/FusionInsight_Current/*_*_DataNode/etc/DN_ISOLATE_DIRS)
    if [ -n "$dnBlackListFile" ]; then
        clean_dir_black_list "${ALARM_DIR}/dn" ${dnBlackListFile}
        setDnDirConf "${ALARM_DIR}/dn"
    fi
    LOG "INFO" "dn dir black list clean finished."
}


################################
#Ŀ¼ָ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_mount_ok()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) mount ok."

    #ӲĿ¼б޳${ALARM_DIR}
    grep "${ALARM_DIR}" ${DISABLE_DIR_LIST} > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        sed -i "s|^${ALARM_DIR}$||g" ${DISABLE_DIR_LIST}
        sed -i "/^$/d" ${DISABLE_DIR_LIST}
        chown omm:wheel ${DISABLE_DIR_LIST}
        LOG "INFO" "Set ${DISABLE_DIR_LIST} files permission is $(ls -ld ${DISABLE_DIR_LIST}) and be Removed"
    fi

    #datanode̺
    handle_dir_black_list

    #datanode
    restart_datanode
    #impala
    handle_impala_mount_ok
    #for NodeManager
    chmodForNodemanager
    #Elk
    handle_Elk_mount_ok

    return 0
}


################################
#Ŀ¼豸ʧ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_partition_lost()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) lost."

    #ѶʧӲ̵ĹڵӵĿ¼б
    grep "${ALARM_DIR}" ${DISABLE_DIR_LIST} > /dev/null 2>&1
    if [ $? -ne 0 ]; then
        echo "${ALARM_DIR}" >> ${DISABLE_DIR_LIST}
    fi

    chown omm:wheel ${DISABLE_DIR_LIST}
    LOG "INFO" " Set ${DISABLE_DIR_LIST} files permission is $(ls -ld ${DISABLE_DIR_LIST})"
    #impala
    handle_impala_partition_lost

    return 0
}


################################
#Ŀ¼ֻ澯
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_readonly()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly."

    #
    return 0
}


################################
#Ŀ¼ָֻ
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_resume_readonly()
{
    LOG "INFO" "module(${ALARM_MODULE}): dir(${ALARM_DIR}) readonly resume."

    #datanode
    restart_datanode

    #for NodeManager
    chmodForNodemanager

    return 0
}

function nodemanager_chmod_dirs()
{
    local nm_dirs="$1"
    local tmp_dir=""
    local file_group=""
    local exist_parent_dir=""

    for nm_dir in ${nm_dirs//,/ }; do

        tmp_dir="$nm_dir"

        while true; do
            if [ -d "$tmp_dir" ]; then
                exist_parent_dir=$(cd "$tmp_dir"; pwd)
                break
            fi

            tmp_dir=$(dirname "${tmp_dir}")
        done

        if [ ! -d "${nm_dir}" ]; then
            mkdir -p "${nm_dir}"
        fi

        chmod 755 "${nm_dir}"
        chown omm:ficommon "${nm_dir}"
        LOG "INFO" "Set ${nm_dir} files permission is $(ls -ld ${nm_dir})"
        tmp_dir=$(cd "${nm_dir}"; pwd)

        while true; do
            tmp_dir=$(dirname "${tmp_dir}")

            if [ "${tmp_dir}" == "/" ]; then
                break
            fi

            file_group=$(stat -c "%G" "$tmp_dir")

            if [ ${#tmp_dir} -gt ${#exist_parent_dir} ]; then
                chmod 750 "${tmp_dir}"
                chown omm:ficommon "${tmp_dir}"
                LOG "INFO" "Set ${tmp_dir} files permission is $(ls -ld ${tmp_dir})"
            else
                chmod u+x "$tmp_dir"
                if [ "$file_group" == "ficommon" ]; then
                    chmod g+x "$tmp_dir"
                else
                    chmod o+x "$tmp_dir"
                fi
            fi
	    LOG "INFO" "Set ${tmp_dir} files permission is $(ls -ld ${tmp_dir})"
        done
    done
}


function chmodForNodemanager()
{
    local nmConfFile=$(find "${DISKMGT_BIGDATA_HOME}"/FusionInsight_Current/*_*_NodeManager/etc/yarn-site.xml)
    [ -z "$nmConfFile" ] && return 0

    local nmLocalDirs=$(awk '{printf "%s", $0}' "$nmConfFile" | awk -F"yarn.nodemanager.local-dirs" '{print $2}' | awk -F"</[]*value[ ]*>" '{print $1}' | awk -F"<[ ]*value[ ]*>" '{print $2}')
    local nmLogDirs=$(awk '{printf "%s", $0}' "$nmConfFile" | awk -F"yarn.nodemanager.log-dirs" '{print $2}' | awk -F"</[]*value[ ]*>" '{print $1}' | awk -F"<[ ]*value[ ]*>" '{print $2}')

    LOG "INFO" "whoami=$(whoami), nmLocalDirs=${nmLocalDirs}, nmLogDirs:${nmLogDirs}"

    nodemanager_chmod_dirs "$nmLocalDirs"
    nodemanager_chmod_dirs "$nmLogDirs"
    return 0

}

#ִ
main
exit $?

