#!/bin/bash

########################################################################################
########################################################################################
#һĸ֪ͨӿ
#--------------------------------------------------
#"0"   "2"   "${dir}" "${module}"  "mount ok"
#"1"   "2"   "${dir}" "${module}"  "partiton lost"
#"2"   "0"   "${dir}" "${module}"  "readonly"
#"2"   "1"   "${dir}" "${module}"  "readonly resume"
#--------------------------------------------------
#1Ϊ澯ID
#0Ŀ¼Ϊã֮ǰĿ¼ạ̃ҵµָ̻
#1Ŀ¼Ϊãص̷ʧ̣
#2Ŀ¼Ϊֻ: ִmount鿴ro
#
#2Ϊ澯
#0澯
#1ָ澯
#2¼ָ
#
#3ΪĿ¼/srv/BigData/datanode1
#
#4Ϊģ
#
#5ΪϢ
########################################################################################
########################################################################################

##
ParaNum=5  #Ϸ
RESULT=0   #ֵ

##5ζ
ALARM_ID=0
ALARM_TYPE=0
ALARM_DIR=""
ALARM_MODULE=""
ALARM_INFO=""

##ӡ
echo `date` "`basename $0` paras:" "[$*]"
echo `date` "`basename $0` para[1]:" "$1"
echo `date` "`basename $0` para[2]:" "$2"
echo `date` "`basename $0` para[3]:" "$3"
echo `date` "`basename $0` para[4]:" "$4"
echo `date` "`basename $0` para[5]:" "$5"

if [ $# -ne ${ParaNum} ]; then
    echo `date` "`basename $0` failed: paras num($#) is not ${ParaNum}"
    exit 1
fi


##ȷϷʼֵ
ALARM_ID=$1
ALARM_TYPE=$2
ALARM_DIR="$3"   #Ŀ¼
ALARM_MODULE="$4"   #ģzookkeep,bookeeperȣԲע
ALARM_INFO="$5"  #ϢԲע

#
declare -r OMM_USER="omm"
declare -r SCRIPT_FILE_NAME="sbin/dbom_recover.sh"
declare -r DB_CREATER="ommdba"
declare SCCRIPT_HOME=""
declare ACTIVE_DBSERVER="active"
declare STANDBY_DBSERVER="standby"
declare CLOUD_FLAG_FILE="/usr/local/diskmgt/ini/cloud"
declare DISKMGT_NOTIFY_LOG_HOME="/var/log/diskmgt/notify"
declare LOGFILE="${DISKMGT_NOTIFY_LOG_HOME}/dbdata_service_notify.log"
declare IS_DBSERVICE_INSTALLED="false"
declare DBSERVICE_ENV_VARS=""
declare DBSERVICE_DATA_DIR=""
declare LOCAL_IP=""
declare PEER_IP=""

if [[ $UID -ne 0 ]]; then
    DISKMGT_BIGDATA_HOME="${BIGDATA_HOME}"
else
    DISKMGT_BIGDATA_HOME="$(su - omm -c 'echo $BIGDATA_HOME')"
fi

if [ -z "${DISKMGT_BIGDATA_HOME}" ]; then
    DISKMGT_BIGDATA_HOME="/opt/huawei/Bigdata"
fi


###############################################################
# ־
###############################################################
function LOG()
{
    local log_size=0

    if [ ! -d ${DISKMGT_NOTIFY_LOG_HOME} ]; then
        mkdir -p ${DISKMGT_NOTIFY_LOG_HOME}
        chown root:root ${DISKMGT_NOTIFY_LOG_HOME}
        chmod 700 ${DISKMGT_NOTIFY_LOG_HOME}
    fi
    
    if [ ! -e "$LOGFILE" ]; then
        touch "$LOGFILE"
        chown root:root "$LOGFILE"
        chmod 600 ${LOGFILE}
        LOG "INFO" "${LINENO}: Set ${LOGFILE} files permission is $(ls -ld ${LOGFILE})"
    fi

    printf "`date -d today +\"%Y-%m-%d %H:%M:%S\"`,000 $1 $2\n" >> "$LOGFILE" 2>/dev/null

    log_size=`du -ms $LOGFILE |cut -f1`
    if [ $log_size -gt 50 ]; then
        #־ļ50M򱸷־ļ
        mv ${LOGFILE} ${LOGFILE}_bak
        LOG "INFO" "${LINENO}: Change the ${LOGFILE}_bak files permission to $(ls -ld ${LOGFILE}_bak)"
    fi
}

################################################################################
# Function: get_env_vars
# Description: ȡDBServiceENV_VARSļֵDBSERVICE_ENV_VARS
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_env_vars()
{
    # Ŀ¼ļ·etc_UPDATEDڣʹetc_UPDATED·µļ
    local currentConfigFile=${DISKMGT_BIGDATA_HOME}/FusionInsight_Current/*_*_DBServer/etc/ENV_VARS
    local updateConfigFile=${DISKMGT_BIGDATA_HOME}/FusionInsight_Current/*_*_DBServer/etc_UPDATED/ENV_VARS
    
    if [ -f ${updateConfigFile} ]; then
        DBSERVICE_ENV_VARS=${updateConfigFile}
        IS_DBSERVICE_INSTALLED="true"
    elif [ -f ${currentConfigFile} ]; then
        DBSERVICE_ENV_VARS=${currentConfigFile}
        IS_DBSERVICE_INSTALLED="true"
    else
        LOG "INFO" "${LINENO}: DBServer is not install at this node."
    fi
    
    LOG "INFO" "${LINENO}: DBServer ENV_VARS path: ${DBSERVICE_ENV_VARS}."
    return 0
}

################################################################################
# Function: init_parameter
# Description: ʼû
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
init_parameter()
{
    # ȡDBServiceENV_VARSļ·
    get_env_vars
    
    if [ "${IS_DBSERVICE_INSTALLED}" = "false" ]; then
        LOG "INFO" "${LINENO}: DBServer is not install at this node."
        return 0
    fi
    
    # ļлȡĿ¼Ӧֵδȡش255
    local dataDir=$(su - omm -c "source ${DBSERVICE_ENV_VARS}; echo \$DBSERVICE_DATA_DIR")
    DBSERVICE_DATA_DIR="$(readlink -m ${dataDir})"
    
    if [ -z "${DBSERVICE_DATA_DIR}" ]; then
        LOG "INFO" "${LINENO}: Failed to get DBServer DBSERVICE_DATA_DIR in ${DBSERVICE_ENV_VARS}."
        return 1
    else
        LOG "INFO" "${LINENO}: Get DBServer DBSERVICE_DATA_DIR ${DBSERVICE_DATA_DIR}."
        return 0
    fi
}

########################################################################################
# Function: is_dir_in_use
# Description: жϴĿ¼ǷΪĿ¼ʹãʹ򷵻0δʹ÷1ڲ󷵻255
# ʵδװδʹøĿ¼1
# Parameter: 
#   input: ·
#   N/A
# Return: 0 -- in use; 1 -- not in use; 255 -- internal error
# Others: N/A
########################################################################################
is_dir_in_use()
{
    # ¼ӦĹĿ¼
    local mountDir=${1}
    
    if [ "${IS_DBSERVICE_INSTALLED}" = "false" ]; then
        LOG "INFO" "${LINENO}: DBServer is not install at this node."
        return 1
    fi
    
    if [ -z ${DBSERVICE_DATA_DIR} ]; then
        LOG "ERROR" "${LINENO}: DBSERVICE_DATA_DIR is empty."
        return 255
    fi
    
    # жϴ˴η¼ӦĹصĿ¼ǷĿ¼Сڣ˵ʵʹˣ0δʹã1
    local dataDir="$(readlink -m ${DBSERVICE_DATA_DIR})"
    local currentDir="$(readlink -m ${mountDir}/dbdata_service/data)"
    if [ "${dataDir}" = "${currentDir}" ]; then
        LOG "INFO" "${LINENO}: Match ${mountDir} in config value ${dataDir}. So ${mountDir} is used by DBServer."
        return 0
    else
        LOG "INFO" "${LINENO}: Cann't match ${mountDir} in config value ${dataDir}. So ${mountDir} is not used by DBServer."
        return 1
    fi
}

################################
#߼
################################
function main()
{
    #õǰumask
    UMASK=0077
    umask "$UMASK"
    
    init_parameter
    if [ $? -ne 0 ]; then
        LOG "ERROR" "${LINENO}: Failed to init parameter for DBService."
        return 1
    fi
    
    # жǷ񻷾ԼĿ¼ǷʵʹãϻұûʹõǰĿ¼űֱӷسɹis_dir_in_use255˵űִʧܣűҪԷ0ֵ˳Ҫִзؽӿڵҵ
    if [ -f ${CLOUD_FLAG_FILE} ]; then
        is_dir_in_use ${ALARM_DIR}
        local retVal=$?
        if [ $retVal -eq 1 ]; then
            LOG "INFO" "${LINENO}: ${ALARM_DIR} is not used by DBService in cloud cluster. Skip to execute partition envent."
            return 0
        elif [ $retVal -eq 255 ]; then
            LOG "INFO" "${LINENO}: Failed to judge whether ${ALARM_DIR} is used by DBService in cloud cluster."
            return 1
        fi
    fi
    
    if [ ${ALARM_ID} -eq 0 ]; then
        echo `date` "handle mount ok."
        handle_mount_ok  #Ŀ¼ָ¼
        return $?
    elif [ ${ALARM_ID} -eq 1 ]; then
        echo `date` "handle partition lost."
        handle_partition_lost #Ŀ¼豸ʧ¼
        return $?
    elif [ ${ALARM_ID} -eq 2 ]; then
        if [ ${ALARM_TYPE} -eq 0 ]; then
            echo `date` "handle ro."
            handle_readonly  #Ŀ¼ֻ澯
            return $?
        elif [ ${ALARM_TYPE} -eq 1 ]; then
            echo `date` "handle ro resume."
            handle_resume_readonly  #Ŀ¼ָֻ
            return $?
        else
            echo "Invalid AlarmType(${ALARM_TYPE})!"
            return 1
        fi
    else
        echo "Invalid AlarmID(${ALARM_ID})!"
        return 1
    fi
}

################################################################################
# Function: get_peer_ip
# Description: ȡԶ˺ͱεip
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_peer_ip()
{
    LOG  "INFO" "Start to get peer ip info ..."

    # ȡΪĶԶ˵ip
    local ipList=$(su - omm -c "source ${DBSERVICE_ENV_VARS}; echo \$DBSERVICE_LIST")
    local ip1="$(echo ${ipList} | awk -F ',' '{print $1}' | tr -s '\n')"
    local ip2="$(echo ${ipList} | awk -F ',' '{print $2}' | tr -s '\n')"
    if [ -z "${ip1}" ] || [ -z "${ip2}" ]; then
        LOG  "INFO" "Value of ip1 [$ip1] or ip2 [$ip2] splited from ipList [$ipList] is invalid."
        return 1
    else
        LOG  "INFO" "Get DBServer1 ip [$ip1] and DBServer2 ip [$ip2] from ipList [$ipList]."
    fi
    
    local localIP=$(hostname -i)
    if [ "${localIP}" =  "${ip1}" ] ; then
        LOCAL_IP="${ip1}"
        PEER_IP="${ip2}"
    elif [ "${localIP}" =  "${ip2}" ] ; then
        LOCAL_IP="${ip2}"
        PEER_IP="${ip1}"
    else
        LOG  "ERROR" "Local ip ${localIP} is not in DBService ipList [$ipList]."
        return 1
    fi
    
    LOG  "INFO" "DBServer local ip [$LOCAL_IP] and peer ip [$PEER_IP]."
    return 0
}

################################################################################
# Function: recover_db_dir_and_config
# Description:ָݿĿ¼ļ
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
recover_db_dir_and_config()
{
    local haScript=${DISKMGT_BIGDATA_HOME}/FusionInsight_Current/*_*_DBServer/install/ha/module/hacom/script/get_harole.sh
    local haStatus=$(su - omm -c "sh ${haScript}")
    if [ "${haStatus}" != "${STANDBY_DBSERVER}" ]; then
       LOG "ERROR" "${LINENO}: Current DBServer status ${haStatus} is not ${STANDBY_DBSERVER}."
       return 1
    fi
     
    su - ${OMM_USER} -c "mkdir -p ${DBSERVICE_DATA_DIR}"  >> "$LOGFILE" 2>&1
    if [ $? -ne 0 ]; then
       LOG "ERROR" "${LINENO}: Failed to mkdir -p ${DBSERVICE_DATA_DIR} with user ${OMM_USER}."
       return 1
    fi
    
    su - ${OMM_USER} -c "chown ${OMM_USER}:wheel ${DBSERVICE_DATA_DIR} -R"  >> "$LOGFILE" 2>&1
    if [ $? -ne 0 ]; then
       LOG "ERROR" "${LINENO}: Failed to chown ${OMM_USER}:wheel ${DBSERVICE_DATA_DIR} -R with user ${OMM_USER}."
       return 1
    fi
    
    su - ${OMM_USER} -c "chmod 700 ${DBSERVICE_DATA_DIR}"  >> "$LOGFILE" 2>&1
    if [ $? -ne 0 ]; then
       LOG "ERROR" "${LINENO}: Failed to chmod 700 ${DBSERVICE_DATA_DIR} with user ${OMM_USER}."
       return 1
    fi
    
    get_peer_ip
    if [ $? -ne 0 ]; then
       LOG "ERROR" "${LINENO}: Failed to get DBServer peer ip."
       return 1
    fi
    
    local db_config_file="$DBSERVICE_DATA_DIR/postgresql.conf"
    if [ -f  "${db_config_file}" ]; then
        LOG "INFO" "${LINENO}: ${db_config_file} exists, remove and rebuild"
        su - ${OMM_USER} -c "rm -rf  ${db_config_file}" >> "$LOGFILE" 2>&1
    fi
    
    su - ${OMM_USER} -c "scp ${OMM_USER}@${PEER_IP}:${db_config_file} $DBSERVICE_DATA_DIR/"
    if [ $? -ne 0 ]; then
       LOG "ERROR" "${LINENO}: Failed to execute command [scp ${OMM_USER}@${PEER_IP}:${db_config_file} $DBSERVICE_DATA_DIR/] with user ${OMM_USER}."
       return 1
    fi
    
    local content="replconninfo1 = \'localhost=${LOCAL_IP} localport=20050 remotehost=${PEER_IP} remoteport=20050\'"
    su - ${OMM_USER} -c "sed -i /replconninfo1[[:blank:]]*=.*/d ${db_config_file}" >> "$LOGFILE" 2>&1
    if [ $? -ne 0 ]; then
       LOG "ERROR" "${LINENO}: Failed to remove replconninfo1 in file ${db_config_file}."
       return 1
    fi
    su - ${OMM_USER} -c "echo ${content} >> ${db_config_file}" >> "$LOGFILE" 2>&1
    if [ $? -ne 0 ]; then
       LOG "ERROR" "${LINENO}: Failed to add replconninfo1 in file ${db_config_file}."
       return 1
    fi
    
    local dbserviceProfile=${DISKMGT_BIGDATA_HOME}/FusionInsight_Current/*_*_DBServer/install/.dbservice_profile
    if [ ! -f ${dbserviceProfile} ]; then
       LOG "ERROR" "${LINENO}: ${dbserviceProfile} not found."
       return 1
    fi
    
    su - ${OMM_USER} -c "source ${dbserviceProfile}; gs_ctl -D \$GAUSSDATA stop -m i"  >> "$LOGFILE" 2>&1
    if [ ! -f ${dbserviceProfile} ]; then
       LOG "ERROR" "${LINENO}: ${dbserviceProfile} not found."
       return 1
    fi

    LOG "INFO" "${LINENO}: Success to recover db dir and config."
    return 0
}

################################
#Ŀ¼ָ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_mount_ok()
{
    LOG "INFO" "${LINENO}: module(${ALARM_MODULE}): for dir(${ALARM_DIR}) mount ok."

    #ʼ
    init_parameter
     if [  $? != 0 ]; then
        LOG "ERROR" "${LINENO}: dbservice_recover  init_parameter failed."
        return 1
      fi

    #ִлָ
    local user=$(id -un)
    if [ "$user" = "root" ]; then
        recover_db_dir_and_config
        ret=$?
    else
        LOG "ERROR" "Operate user is not root, please change to root."
        ret=1
    fi
    
    if [  $ret != 0 ]; then
       LOG "ERROR" "${LINENO}: dbservice_recover  handle_mount_ok failed."
       return 1
    fi

    return 0
}

################################
#Ŀ¼豸ʧ¼
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_partition_lost()
{
    LOG "INFO" "${LINENO}: module(${ALARM_MODULE}): for dir(${ALARM_DIR}) lost."

    return 0
}


################################
#Ŀ¼ֻ澯
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_readonly()
{
    LOG "INFO" "${LINENO}: module(${ALARM_MODULE}): for dir(${ALARM_DIR}) readonly."

    return 0
}


################################
#Ŀ¼ָֻ
#ֻҪӴ
#ɹ0򷵻ط0
################################
function handle_resume_readonly()
{
    LOG "INFO" "${LINENO}: module(${ALARM_MODULE}): for dir(${ALARM_DIR}) readonly resume."

    return 0
}


#ִ
main
exit $?

