#!/bin/bash
###################################################
# : OS
###################################################

###################################################
# ں 
# ע:
#   ģļй: λ + . + 
#                   ֻӢĺ»
#   : 070.autopart еΪ autopart
#
#   ں:   ģļе[] + _upgrade_main
###################################################
function autopart_upgrade_main()
{
    local path="$1"
    local name=""
    local file=""
    local sched_pid=0
    local ret=0
    
    debug "Enter [${FUNCNAME}:${LINENO}]"

    
    file="${gc_mian_path}/${path}/autopart/upgradedmgt.sh"
    
    if [ ! -f "${file}" ]; then
        info "[${FUNCNAME}:${LINENO}]" "Don't need to upgrade about ${name}"
        return 0
    fi
    
    #ļ
    echo 0 > "${gc_p_sched_file}"
    
    #ȡȵĺ̨
    bash ${gc_mian_path}/${path}/schedule.sh "${gc_p_sched_file}" "${gc_sched_file}" &
    
    #̵̨PID
    sched_pid=$!
        
    if [ ${gc_action} == "COMMIT" ]; then
        bash ${file} -c
        ret=$?
    elif [ ${gc_action} == "UPGRADE" ]; then
        bash ${file} -s
        ret=$?
    elif [ ${gc_action} == "ROLL_BACK" ]; then
        bash ${file} -r 
        ret=$?
    else
        ret=1
    fi
    
    #̨
    kill $sched_pid
    
    if [ $ret -ne 0 ]; then
        error "[${FUNCNAME}:${LINENO}]" "run ${file} failed."
        return $ret
    fi
    
    debug "Leave [${FUNCNAME}:${LINENO}]"
    
    return 0
}
